
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Budget_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const budget_lines = await db.budget_lines.create(
            {
                id: data.id || undefined,
        
        category: data.category
        ||
        null
            ,
            
        planned_amount: data.planned_amount
        ||
        null
            ,
            
        actual_amount: data.actual_amount
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await budget_lines.setBudget( data.budget || null, {
            transaction,
        });
        
        await budget_lines.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return budget_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const budget_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                category: item.category
            ||
            null
            ,
            
                planned_amount: item.planned_amount
            ||
            null
            ,
            
                actual_amount: item.actual_amount
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const budget_lines = await db.budget_lines.bulkCreate(budget_linesData, { transaction });

        // For each item created, replace relation files
        

        return budget_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const budget_lines = await db.budget_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.category !== undefined) updatePayload.category = data.category;
        
        
        if (data.planned_amount !== undefined) updatePayload.planned_amount = data.planned_amount;
        
        
        if (data.actual_amount !== undefined) updatePayload.actual_amount = data.actual_amount;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await budget_lines.update(updatePayload, {transaction});

        
        
        if (data.budget !== undefined) {
            await budget_lines.setBudget(
              
              data.budget,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await budget_lines.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return budget_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const budget_lines = await db.budget_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of budget_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of budget_lines) {
                await record.destroy({transaction});
            }
        });


        return budget_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const budget_lines = await db.budget_lines.findByPk(id, options);

        await budget_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await budget_lines.destroy({
            transaction
        });

        return budget_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const budget_lines = await db.budget_lines.findOne(
            { where },
            { transaction },
        );

        if (!budget_lines) {
            return budget_lines;
        }

        const output = budget_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.budget = await budget_lines.getBudget({
            transaction
        });
        
        
        output.organizations = await budget_lines.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.budgets,
        as: 'budget',
        
        where: filter.budget ? {
          [Op.or]: [
            { id: { [Op.in]: filter.budget.split('|').map(term => Utils.uuid(term)) } },
            {
              budget_name: {
                [Op.or]: filter.budget.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'budget_lines',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.planned_amountRange) {
                const [start, end] = filter.planned_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    planned_amount: {
                    ...where.planned_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    planned_amount: {
                    ...where.planned_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.actual_amountRange) {
                const [start, end] = filter.actual_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    actual_amount: {
                    ...where.actual_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    actual_amount: {
                    ...where.actual_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.category) {
                where = {
                    ...where,
                category: filter.category,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.budget_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'budget_lines',
                        'category',
                        query,
                    ),
                ],
            };
        }

        const records = await db.budget_lines.findAll({
            attributes: [ 'id', 'category' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['category', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.category,
        }));
    }

    
};

